Index: c/src/lib/libbsp/powerpc/mpc8260ads/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/ChangeLog	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/ChangeLog	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/powerpc/mpc8260ads/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/include/bsp.h	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/include/bsp.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -73,28 +73,4 @@
 */
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 0
-
-#define Install_tm27_vector( handler ) \
-   do { \
-	static rtems_irq_connect_data scIrqData = { \
-	  PPC_IRQ_SCALL, \
-	  (rtems_irq_hdl) handler, \
-	  NULL, \
-	  NULL, \
-	  NULL  \
-	}; \
-	BSP_install_rtems_irq_handler (&scIrqData); \
-   } while(0)
-
-#define Cause_tm27_intr() asm volatile ("sc")
-
-#define Clear_tm27_intr()
-
-#define Lower_tm27_intr()
-
 /* Constants */
 /*
Index: c/src/lib/libbsp/powerpc/mpc8260ads/include/tm27.h
===================================================================
--- c/src/lib/libbsp/powerpc/mpc8260ads/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
+++ c/src/lib/libbsp/powerpc/mpc8260ads/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -0,0 +1,42 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 0
+
+#define Install_tm27_vector( handler ) \
+   do { \
+	static rtems_irq_connect_data scIrqData = { \
+	  PPC_IRQ_SCALL, \
+	  (rtems_irq_hdl) handler, \
+	  NULL, \
+	  NULL, \
+	  NULL  \
+	}; \
+	BSP_install_rtems_irq_handler (&scIrqData); \
+   } while(0)
+
+#define Cause_tm27_intr() asm volatile ("sc")
+
+#define Clear_tm27_intr()
+
+#define Lower_tm27_intr()
+
+#endif
Index: c/src/lib/libbsp/powerpc/ppcn_60x/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/ppcn_60x/ChangeLog	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/ppcn_60x/ChangeLog	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/powerpc/ppcn_60x/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/ppcn_60x/include/bsp.h	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/ppcn_60x/include/bsp.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -355,34 +355,4 @@
   (int) (((_value) * 4000) / (ulCpuBusClock/10000))
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 1
-
-#define Install_tm27_vector( _handler ) \
-  set_vector( (_handler), PPC_IRQ_DECREMENTER, 1 )
-
-#define Cause_tm27_intr()  \
-  do { \
-    uint32_t   _clicks = 8; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
-  } while (0)
-
-#define Clear_tm27_intr() \
-  do { \
-    uint32_t   _clicks = 0xffffffff; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
-  } while (0)
-
-#define Lower_tm27_intr() \
-  do { \
-    uint32_t   _msr = 0; \
-    _ISR_Set_level( 0 ); \
-    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
-    _msr |=  0x8002; \
-    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
-  } while (0)
-
 /* Constants */
 
Index: c/src/lib/libbsp/powerpc/ppcn_60x/include/tm27.h
===================================================================
--- c/src/lib/libbsp/powerpc/ppcn_60x/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
+++ c/src/lib/libbsp/powerpc/ppcn_60x/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -0,0 +1,48 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+#define Install_tm27_vector( _handler ) \
+  set_vector( (_handler), PPC_IRQ_DECREMENTER, 1 )
+
+#define Cause_tm27_intr()  \
+  do { \
+    uint32_t   _clicks = 8; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Clear_tm27_intr() \
+  do { \
+    uint32_t   _clicks = 0xffffffff; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Lower_tm27_intr() \
+  do { \
+    uint32_t   _msr = 0; \
+    _ISR_Set_level( 0 ); \
+    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+    _msr |=  0x8002; \
+    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+  } while (0)
+
+#endif
Index: c/src/lib/libbsp/powerpc/psim/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/psim/ChangeLog	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/psim/ChangeLog	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/powerpc/psim/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/psim/include/bsp.h	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/psim/include/bsp.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -58,34 +58,4 @@
 #include <rtems/console.h>
 #include <rtems/iosupp.h>
-
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 1
-
-#define Install_tm27_vector( _handler ) \
-  set_vector( (_handler), PPC_IRQ_DECREMENTER, 1 )
-
-#define Cause_tm27_intr()  \
-  do { \
-    uint32_t   _clicks = 1; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
-  } while (0)
-
-#define Clear_tm27_intr() \
-  do { \
-    uint32_t   _clicks = 0xffffffff; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
-  } while (0)
-
-#define Lower_tm27_intr() \
-  do { \
-    uint32_t   _msr = 0; \
-    _ISR_Set_level( 0 ); \
-    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
-    _msr |=  0x8002; \
-    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
-  } while (0)
 
 /* Constants */
Index: c/src/lib/libbsp/powerpc/psim/include/tm27.h
===================================================================
--- c/src/lib/libbsp/powerpc/psim/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
+++ c/src/lib/libbsp/powerpc/psim/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -0,0 +1,48 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+#define Install_tm27_vector( _handler ) \
+  set_vector( (_handler), PPC_IRQ_DECREMENTER, 1 )
+
+#define Cause_tm27_intr()  \
+  do { \
+    uint32_t   _clicks = 1; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Clear_tm27_intr() \
+  do { \
+    uint32_t   _clicks = 0xffffffff; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Lower_tm27_intr() \
+  do { \
+    uint32_t   _msr = 0; \
+    _ISR_Set_level( 0 ); \
+    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+    _msr |=  0x8002; \
+    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+  } while (0)
+
+#endif
Index: c/src/lib/libbsp/powerpc/score603e/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/ChangeLog	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/score603e/ChangeLog	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Ralf Corsepius <ralf_corsepius@rtems.org>
 
Index: c/src/lib/libbsp/powerpc/score603e/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/include/bsp.h	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/score603e/include/bsp.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -72,34 +72,4 @@
                                SCORE603E_BRD_FLASH_DISABLE_MASK) \
 
-/*
- *  Stuff for Time Test 27
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 1
-
-#define Install_tm27_vector( _handler ) \
-  set_vector( (_handler), PPC_IRQ_DECREMENTER, 1 )
-
-#define Cause_tm27_intr()  \
-  do { \
-    uint32_t   _clicks = 8; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
-  } while (0)
-
-#define Clear_tm27_intr() \
-  do { \
-    uint32_t   _clicks = 0xffffffff; \
-    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
-  } while (0)
-
-#define Lower_tm27_intr() \
-  do { \
-    uint32_t   _msr = 0; \
-    _ISR_Set_level( 0 ); \
-    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
-    _msr |=  0x8002; \
-    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
-  } while (0)
-
 /* Constants */
 
Index: c/src/lib/libbsp/powerpc/score603e/include/tm27.h
===================================================================
--- c/src/lib/libbsp/powerpc/score603e/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
+++ c/src/lib/libbsp/powerpc/score603e/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -0,0 +1,48 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ *  Stuff for Time Test 27
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+#define Install_tm27_vector( _handler ) \
+  set_vector( (_handler), PPC_IRQ_DECREMENTER, 1 )
+
+#define Cause_tm27_intr()  \
+  do { \
+    uint32_t   _clicks = 8; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Clear_tm27_intr() \
+  do { \
+    uint32_t   _clicks = 0xffffffff; \
+    asm volatile( "mtdec %0" : "=r" ((_clicks)) : "r" ((_clicks)) ); \
+  } while (0)
+
+#define Lower_tm27_intr() \
+  do { \
+    uint32_t   _msr = 0; \
+    _ISR_Set_level( 0 ); \
+    asm volatile( "mfmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+    _msr |=  0x8002; \
+    asm volatile( "mtmsr %0 ;" : "=r" (_msr) : "r" (_msr) ); \
+  } while (0)
+
+#endif
Index: c/src/lib/libbsp/powerpc/ss555/ChangeLog
===================================================================
--- c/src/lib/libbsp/powerpc/ss555/ChangeLog	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/ss555/ChangeLog	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -1,2 +1,7 @@
+2004-04-22	Ralf Corsepius <ralf_corsepius@rtems.org>
+
+	* include/bsp.h: Split out tmtest27 support.
+	* include/tm27.h: New.
+
 2004-04-21	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/lib/libbsp/powerpc/ss555/include/bsp.h
===================================================================
--- c/src/lib/libbsp/powerpc/ss555/include/bsp.h	(revision 76488aa308f780bc56be416158ebae08a4c2c4e8)
+++ c/src/lib/libbsp/powerpc/ss555/include/bsp.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -76,40 +76,4 @@
 extern volatile cpld_t cpld;              /* defined in linkcmds */
 
-/*
- * Stuff for Time Test 27
- *
- * The following require that IRQ7 be jumpered to ground.  On the SS555,
- * this can be done by shorting together CN5 pin 48 and CN5 pin 50.
- */
-
-#define MUST_WAIT_FOR_INTERRUPT 1
-
-#define Install_tm27_vector( handler )					\
-{									\
-  extern rtems_irq_connect_data tm27IrqData;                            \
-  usiu.siel |= (1 << 17); 						\
-  usiu.sipend |= (1 << 17); 						\
-									\
-  tm27IrqData.hdl = (rtems_irq_hdl)handler;				\
-  BSP_install_rtems_irq_handler (&tm27IrqData);				\
-}
-
-#define Cause_tm27_intr()						\
-{									\
-  usiu.siel &= ~(1 << 17); 						\
-}
-
-#define Clear_tm27_intr()						\
-{									\
-  usiu.siel |= (1 << 17); 						\
-  usiu.sipend |= (1 << 17); 						\
-}
-
-#define Lower_tm27_intr()						\
-{									\
-  ppc_cached_irq_mask |= (1 << 17);					\
-  usiu.simask = ppc_cached_irq_mask;					\
-}
-
 /* miscellaneous stuff assumed to exist */
 
Index: c/src/lib/libbsp/powerpc/ss555/include/tm27.h
===================================================================
--- c/src/lib/libbsp/powerpc/ss555/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
+++ c/src/lib/libbsp/powerpc/ss555/include/tm27.h	(revision 62f529f43c622e4a329439b3c1f954f6cd856a61)
@@ -0,0 +1,54 @@
+/*
+ *  tm27.h
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifndef _TMTEST27
+#error "This is an RTEMS internal file you must not include directly."
+#endif
+
+#ifndef __tm27_h
+#define __tm27_h
+
+/*
+ * Stuff for Time Test 27
+ *
+ * The following require that IRQ7 be jumpered to ground.  On the SS555,
+ * this can be done by shorting together CN5 pin 48 and CN5 pin 50.
+ */
+
+#define MUST_WAIT_FOR_INTERRUPT 1
+
+#define Install_tm27_vector( handler )					\
+{									\
+  extern rtems_irq_connect_data tm27IrqData;                            \
+  usiu.siel |= (1 << 17); 						\
+  usiu.sipend |= (1 << 17); 						\
+									\
+  tm27IrqData.hdl = (rtems_irq_hdl)handler;				\
+  BSP_install_rtems_irq_handler (&tm27IrqData);				\
+}
+
+#define Cause_tm27_intr()						\
+{									\
+  usiu.siel &= ~(1 << 17); 						\
+}
+
+#define Clear_tm27_intr()						\
+{									\
+  usiu.siel |= (1 << 17); 						\
+  usiu.sipend |= (1 << 17); 						\
+}
+
+#define Lower_tm27_intr()						\
+{									\
+  ppc_cached_irq_mask |= (1 << 17);					\
+  usiu.simask = ppc_cached_irq_mask;					\
+}
+
+#endif