Index: c/src/lib/libcpu/m68k/ChangeLog
===================================================================
--- c/src/lib/libcpu/m68k/ChangeLog	(revision 440002fda5237a4fa92ec99e3204a9f1d11ea20b)
+++ c/src/lib/libcpu/m68k/ChangeLog	(revision 67c9abf43ccd541cca57e7532253565ca1884606)
@@ -1,2 +1,7 @@
+2005-01-02	Ralf Corsepius <ralf.corsepius@rtems.org>
+
+	* m68040/Makefile.am, mcf5206/Makefile.am, mcf5272/Makefile.am,
+	shared/Makefile.am: Remove build-variant support.
+
 2005-01-02	Ralf Corsepius <ralf.corsepius@rtems.org>
 
Index: c/src/lib/libcpu/m68k/m68040/Makefile.am
===================================================================
--- c/src/lib/libcpu/m68k/m68040/Makefile.am	(revision 440002fda5237a4fa92ec99e3204a9f1d11ea20b)
+++ c/src/lib/libcpu/m68k/m68040/Makefile.am	(revision 67c9abf43ccd541cca57e7532253565ca1884606)
@@ -3,13 +3,10 @@
 ##
 
-EXTRA_PROGRAMS =
-CLEANFILES =
-noinst_DATA =
+noinst_PROGRAMS =
 
 include $(top_srcdir)/../../../automake/compile.am
 
 if m68040
-EXTRA_PROGRAMS += fpsp.rel
-CLEANFILES += fpsp.rel
+noinst_PROGRAMS += fpsp.rel
 fpsp_rel_SOURCES = fpsp/rtems_fpsp.c fpsp/bindec.S fpsp/binstr.S \
     fpsp/bugfix.S fpsp/decbin.S fpsp/do_func.S fpsp/gen_except.S \
@@ -25,12 +22,4 @@
 fpsp_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-EXTRA_PROGRAMS += fpsp_g.rel
-CLEANFILES += fpsp_g.rel
-fpsp_g_rel_SOURCES = $(fpsp_rel_SOURCES)
-fpsp_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-fpsp_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += fpsp$(LIB_VARIANT).rel
-
 noinst_HEADERS = fpsp/fpsp.defs
 endif
Index: c/src/lib/libcpu/m68k/mcf5206/Makefile.am
===================================================================
--- c/src/lib/libcpu/m68k/mcf5206/Makefile.am	(revision 440002fda5237a4fa92ec99e3204a9f1d11ea20b)
+++ c/src/lib/libcpu/m68k/mcf5206/Makefile.am	(revision 67c9abf43ccd541cca57e7532253565ca1884606)
@@ -5,7 +5,5 @@
 include $(top_srcdir)/../../../automake/compile.am
 
-CLEANFILES =
-EXTRA_PROGRAMS =
-noinst_DATA =
+noinst_PROGRAMS =
 
 if mcf5206
@@ -17,62 +15,26 @@
 
 ## clock
-EXTRA_PROGRAMS += clock.rel
-CLEANFILES += clock.rel
+noinst_PROGRAMS += clock.rel
 clock_rel_SOURCES = clock/ckinit.c
 clock_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 clock_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-EXTRA_PROGRAMS += clock_g.rel
-CLEANFILES += clock_g.rel
-clock_g_rel_SOURCES = $(clock_rel_SOURCES)
-clock_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-clock_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += clock$(LIB_VARIANT).rel
-
 ## mcfuart
-EXTRA_PROGRAMS += mcfuart.rel
-CLEANFILES += mcfuart.rel
+noinst_PROGRAMS += mcfuart.rel
 mcfuart_rel_SOURCES = console/mcfuart.c
 mcfuart_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 mcfuart_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-EXTRA_PROGRAMS += mcfuart_g.rel
-CLEANFILES += mcfuart_g.rel
-mcfuart_g_rel_SOURCES = $(mcfuart_rel_SOURCES)
-mcfuart_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-mcfuart_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += mcfuart$(LIB_VARIANT).rel
-
 ## mbus
-EXTRA_PROGRAMS += mbus.rel
-CLEANFILES += mbus.rel
+noinst_PROGRAMS += mbus.rel
 mbus_rel_SOURCES = mbus/mcfmbus.c
 mbus_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 mbus_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-EXTRA_PROGRAMS += mbus_g.rel
-CLEANFILES += mbus_g.rel
-mbus_g_rel_SOURCES = $(mbus_rel_SOURCES)
-mbus_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-mbus_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += mbus$(LIB_VARIANT).rel
-
 ## timer
-EXTRA_PROGRAMS += timer.rel
-CLEANFILES += timer.rel
+noinst_PROGRAMS += timer.rel
 timer_rel_SOURCES = timer/timer.c timer/timerisr.S
 timer_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 timer_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-EXTRA_PROGRAMS += timer_g.rel
-CLEANFILES += timer_g.rel
-timer_g_rel_SOURCES = $(timer_rel_SOURCES)
-timer_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-timer_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += timer$(LIB_VARIANT).rel
 endif
 
@@ -101,5 +63,5 @@
 endif
 
-CLEANFILES += $(PREINSTALL_FILES)
+CLEANFILES = $(PREINSTALL_FILES)
 DISTCLEANFILES = $(PREINSTALL_DIRS)
 
Index: c/src/lib/libcpu/m68k/mcf5272/Makefile.am
===================================================================
--- c/src/lib/libcpu/m68k/mcf5272/Makefile.am	(revision 440002fda5237a4fa92ec99e3204a9f1d11ea20b)
+++ c/src/lib/libcpu/m68k/mcf5272/Makefile.am	(revision 67c9abf43ccd541cca57e7532253565ca1884606)
@@ -5,7 +5,5 @@
 include $(top_srcdir)/../../../automake/compile.am
 
-CLEANFILES =
-EXTRA_PROGRAMS =
-noinst_DATA =
+noinst_PROGRAMS =
 
 if mcf5272
@@ -16,47 +14,25 @@
 
 ## clock
-EXTRA_PROGRAMS += clock.rel
-CLEANFILES += clock.rel
+noinst_PROGRAMS += clock.rel
 clock_rel_SOURCES = clock/ckinit.c
 clock_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 clock_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
-EXTRA_PROGRAMS += clock_g.rel
-CLEANFILES += clock_g.rel
-clock_g_rel_SOURCES = $(clock_rel_SOURCES)
-clock_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-clock_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += clock$(LIB_VARIANT).rel
-
 ## console
 #EXTRA_PROGRAMS += console.rel
-#CLEANFILES += console.rel
-#console_rel_SOURCES = console/console-io.c ../../../../libbsp/shared/console-polled.c
+##console_rel_SOURCES = console/console-io.c ../../../../libbsp/shared/console-polled.c
 #console_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 #console_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 
 #EXTRA_PROGRAMS += console_g.rel
-#CLEANFILES += console_g.rel
-#console_g_rel_SOURCES = $(console_rel_SOURCES)
-#console_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-#console_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
 #
-#noinst_DATA += console$(LIB_VARIANT).rel
+
+#
 
 ## timer
-EXTRA_PROGRAMS += timer.rel
-CLEANFILES += timer.rel
+noinst_PROGRAMS += timer.rel
 timer_rel_SOURCES = timer/timer.c timer/timerisr.S
 timer_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V)
 timer_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-EXTRA_PROGRAMS += timer_g.rel
-CLEANFILES += timer_g.rel
-timer_g_rel_SOURCES = $(timer_rel_SOURCES)
-timer_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V)
-timer_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += timer$(LIB_VARIANT).rel
 endif
 
@@ -77,5 +53,5 @@
 endif
 
-CLEANFILES += $(PREINSTALL_FILES)
+CLEANFILES = $(PREINSTALL_FILES)
 DISTCLEANFILES = $(PREINSTALL_DIRS)
 
Index: c/src/lib/libcpu/m68k/shared/Makefile.am
===================================================================
--- c/src/lib/libcpu/m68k/shared/Makefile.am	(revision 440002fda5237a4fa92ec99e3204a9f1d11ea20b)
+++ c/src/lib/libcpu/m68k/shared/Makefile.am	(revision 67c9abf43ccd541cca57e7532253565ca1884606)
@@ -3,8 +3,5 @@
 ##
 
-CLEANFILES =
-EXTRA_DIST =
-EXTRA_PROGRAMS =
-noinst_DATA =
+noinst_PROGRAMS =
 
 include $(top_srcdir)/../../../automake/compile.am
@@ -16,6 +13,5 @@
 include_libcpu_HEADERS = ../../shared/include/cache.h
 
-EXTRA_PROGRAMS += cache.rel
-CLEANFILES += cache.rel
+noinst_PROGRAMS += cache.rel
 cache_rel_SOURCES = cache/cache.c cache/cache_.h \
     ../../shared/src/cache_aligned_malloc.c \
@@ -23,12 +19,4 @@
 cache_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V) -I$(srcdir)/cache
 cache_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-EXTRA_PROGRAMS += cache_g.rel
-CLEANFILES += cache_g.rel
-cache_g_rel_SOURCES = $(cache_rel_SOURCES)
-cache_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V) -I$(srcdir)/cache
-cache_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += cache$(LIB_VARIANT).rel
 
 ## misc
@@ -42,17 +30,8 @@
 endif
 
-EXTRA_PROGRAMS += misc.rel
-CLEANFILES += misc.rel
+noinst_PROGRAMS += misc.rel
 misc_rel_SOURCES = misc/memcpy.c misc/m68kidle.c
 misc_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_OPTIMIZE_V) $(M68K_CPPFLAGS)
 misc_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-EXTRA_PROGRAMS += misc_g.rel
-CLEANFILES += misc_g.rel
-misc_g_rel_SOURCES = $(misc_rel_SOURCES)
-misc_g_rel_CPPFLAGS = $(AM_CPPFLAGS) $(CFLAGS_DEBUG_V) $(M68K_CPPFLAGS)
-misc_g_rel_LDFLAGS = $(RTEMS_RELLDFLAGS)
-
-noinst_DATA += misc$(LIB_VARIANT).rel
 endif
 
@@ -75,5 +54,5 @@
 endif
 
-CLEANFILES += $(PREINSTALL_FILES)
+CLEANFILES = $(PREINSTALL_FILES)
 DISTCLEANFILES = $(PREINSTALL_DIRS)
 