Index: doc/posix1003.1/Makefile
===================================================================
--- doc/posix1003.1/Makefile	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/Makefile	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -16,5 +16,5 @@
 
 GENERATED_FILES=ch01.texi ch02.texi ch03.texi ch04.texi ch05.texi \
-                ch06.texi ch07.texi ch08.texi ch08.texi ch10.texi \
+                ch06.texi ch07.texi ch08.texi ch09.texi ch10.texi \
                 ch11.texi ch12.texi ch13.texi ch14.texi ch15.texi \
                 ch16.texi ch17.texi ch18.texi 
@@ -31,5 +31,5 @@
 	cp $(PROJECT) $(INFO_INSTALL)
 
-$(P{ROJECT): $(FILES)
+$(PROJECT): $(FILES)
 	$(MAKEINFO) $(PROJECT).texi
 
@@ -53,93 +53,93 @@
 	$(TEXI2DVI) $(PROJECT).texi
 
-ch01.t.texi: ch01.t
-	$(BMENU) -p "Preface" \
+ch01.texi: ch01.t
+	$(BMENU) -c -p "Preface" \
 	    -u "Top" \
-	    -n "Terminology and General Requirements" $*
+	    -n "Terminology and General Requirements" ${*}.t
 
-ch02.t.texi: ch02.t
-	$(BMENU) -p "Conformance" \
+ch02.texi: ch02.t
+	$(BMENU) -c -p "Conformance" \
 	    -u "Top" \
-	    -n "Process Primitives" $*
+	    -n "Process Primitives" ${*}.t
 
-ch03.t.texi: ch03.t
-	$(BMENU) -p "Symbolic Constants" \
+ch03.texi: ch03.t
+	$(BMENU) -c -p "Symbolic Constants" \
 	    -u "Top" \
-	    -n "Process Environment" $*
+	    -n "Process Environment" ${*}.t
 
-ch04.t.texi: ch04.t
-	$(BMENU) -p "Delay Process Execution" \
+ch04.texi: ch04.t
+	$(BMENU) -c -p "Delay Process Execution" \
 	    -u "Top" \
-	    -n "Files and Directories" $*
+	    -n "Files and Directories" ${*}.t
 
-ch05.t.texi: ch05.t
-	$(BMENU) -p "Get Configurable System Variables" \
+ch05.texi: ch05.t
+	$(BMENU) -c -p "Get Configurable System Variables" \
 	    -u "Top" \
-	    -n "Input and Output Primitives" $*
+	    -n "Input and Output Primitives" ${*}.t
 
-ch06.t.texi: ch06.t
-	$(BMENU) -p "Get Configurable Pathname Variables" \
+ch06.texi: ch06.t
+	$(BMENU) -c -p "Get Configurable Pathname Variables" \
 	    -u "Top" \
-	    -n "Device- and Class-Specific Functions" $*
+	    -n "Device- and Class-Specific Functions" ${*}.t
 
-ch07.t.texi: ch07.t
-	$(BMENU) -p " Asynchronous File Synchronization" \
+ch07.texi: ch07.t
+	$(BMENU) -c -p " Asynchronous File Synchronization" \
 	    -u "Top" \
-	    -n "Language-Specific Services for the C Programming Language" $*
+	    -n "Language-Specific Services for the C Programming Language" ${*}.t
 
-ch08.t.texi: ch08.t
-	$(BMENU) -p "Set Foreground Process Group ID" \
+ch08.texi: ch08.t
+	$(BMENU) -c -p "Set Foreground Process Group ID" \
 	    -u "Top" \
-	    -n "System Databases" $*
+	    -n "System Databases" ${*}.t
 
-ch09.t.texi: ch09.t
-	$(BMENU) -p "Pseudo-Random Sequence Generation Functions" \
+ch09.texi: ch09.t
+	$(BMENU) -c -p "Pseudo-Random Sequence Generation Functions" \
 	    -u "Top" \
-	    -n "Data Interchange Format" $*
+	    -n "Data Interchange Format" ${*}.t
 
-ch10.t.texi: ch10.t
-	$(BMENU) -p "User Database Access" \
+ch10.texi: ch10.t
+	$(BMENU) -c -p "User Database Access" \
 	    -u "Top" \
-	    -n "Synchronization" $*
+	    -n "Synchronization" ${*}.t
 
-ch11.t.texi: ch11.t
-	$(BMENU) -p "Multiple Volumes" \
+ch11.texi: ch11.t
+	$(BMENU) -c -p "Multiple Volumes" \
 	    -u "Top" \
-	    -n "Memory Management" $*
+	    -n "Memory Management" ${*}.t
 
-ch12.t.texi: ch12.t
-	$(BMENU) -p "Waiting on a Condition" \
+ch12.texi: ch12.t
+	$(BMENU) -c -p "Waiting on a Condition" \
 	    -u "Top" \
-	    -n "Execution Scheduling" $*
+	    -n "Execution Scheduling" ${*}.t
 
-ch13.t.texi: ch13.t
-	$(BMENU) -p "Remove a Shared Memory Object" \
+ch13.texi: ch13.t
+	$(BMENU) -c -p "Remove a Shared Memory Object" \
 	    -u "Top" \
-	    -n "Clocks and Timers" $*
+	    -n "Clocks and Timers" ${*}.t
 
-ch14.t.texi: ch14.t
-	$(BMENU) -p "Change the Priority Ceiling of a Mutex" \
+ch14.texi: ch14.t
+	$(BMENU) -c -p "Change the Priority Ceiling of a Mutex" \
 	    -u "Top" \
-	    -n "Message Passing" $*
+	    -n "Message Passing" ${*}.t
 
-ch15.t.texi: ch15.t
-	$(BMENU) -p "High Resolution Sleep" \
+ch15.texi: ch15.t
+	$(BMENU) -c -p "High Resolution Sleep" \
 	    -u "Top" \
-	    -n "Thread Management" $*
+	    -n "Thread Management" ${*}.t
 
-ch16.t.texi: ch16.t
-	$(BMENU) -p "Get Message Queue Attributes" \
+ch16.texi: ch16.t
+	$(BMENU) -c -p "Get Message Queue Attributes" \
 	    -u "Top" \
-	    -n "Thread-Specific Data" $*
+	    -n "Thread-Specific Data" ${*}.t
 
-ch17.t.texi: ch17.t
-	$(BMENU) -p "Dynamic Package Initialization" \
+ch17.texi: ch17.t
+	$(BMENU) -c -p "Dynamic Package Initialization" \
 	    -u "Top" \
-	    -n "Thread Cancellation" $*
+	    -n "Thread Cancellation" ${*}.t
 
-ch18.t.texi: ch18.t
-	$(BMENU) -p "Thread-Specific Data Key Deletion" \
+ch18.texi: ch18.t
+	$(BMENU) -c -p "Thread-Specific Data Key Deletion" \
 	    -u "Top" \
-	    -n "Command and Variable Index" $*
+	    -n "Command and Variable Index" ${*}.t
 
 
Index: doc/posix1003.1/ch04.t
===================================================================
--- doc/posix1003.1/ch04.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch04.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -11,5 +11,5 @@
 @subsection Get Process and Parent Process IDs
 @section User Identification
-@subsection Get Real User Effective User, Real Group, and Effective Group IDs
+@subsection Get Real User Effective User Real Group and Effective Group IDs
 @subsection Set User and Group IDs
 @subsection Get Supplementary Group IDs
Index: doc/posix1003.1/ch05.t
===================================================================
--- doc/posix1003.1/ch05.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch05.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -27,5 +27,5 @@
 @subsection Rename a File
 @section File Characteristics
-@subsection File Characteristics: Header and Data Structure
+@subsection File Characteristics Header and Data Structure
 @subsection Get File Status
 @subsection Check File Accessibility
Index: doc/posix1003.1/ch07.t
===================================================================
--- doc/posix1003.1/ch07.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch07.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -11,5 +11,5 @@
 @subsection Interface Characteristics
 @subsubsection Opening a Terminal Device File
-@subsubsection Process Groups
+@subsubsection Process Groups (TTY)
 @subsubsection The Controlling Terminal
 @subsubsection Terminal Access Control
@@ -28,6 +28,6 @@
 @subsubsection Local Modes
 @subsubsection Special Control Characters
-@subsubsection Baud Rate Values
-@subsubsection @subsection Baud Rate Functions
+@subsection Baud Rate Values
+@subsubsection Baud Rate Functions
 @subsubsection Synopsis
 @subsubsection Description
Index: doc/posix1003.1/ch09.t
===================================================================
--- doc/posix1003.1/ch09.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch09.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -1,4 +1,4 @@
 @chapter System Databases
-@section System Databases
+@section System Databases Section
 @section Database Access
 @section Group Database Access
Index: doc/posix1003.1/ch10.t
===================================================================
--- doc/posix1003.1/ch10.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch10.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -9,6 +9,6 @@
 @chapter Data Interchange Format
 @section Archive/Interchange File Format
-@subsubsection Extended tar Format
-@subsubsection Extended cpio Format
-@subsubsection Multiple Volumes
+@subsection Extended tar Format
+@subsection Extended cpio Format
+@subsection Multiple Volumes
 
Index: doc/posix1003.1/ch11.t
===================================================================
--- doc/posix1003.1/ch11.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch11.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -10,20 +10,20 @@
 @section Semaphore Characteristics
 @section Semaphore Functions
-@subsubsection Initialize an Unnamed Semaphore
-@subsubsection Destroy an Unnamed Semaphore
-@subsubsection Initialize/Open a Named Semaphore
-@subsubsection Close a Named Semaphore
-@subsubsection Remove a Named Semaphore
-@subsubsection Lock a Semaphore
-@subsubsection Unlock a Semaphore
-@subsubsection Get the Value of a Semaphore
+@subsection Initialize an Unnamed Semaphore
+@subsection Destroy an Unnamed Semaphore
+@subsection Initialize/Open a Named Semaphore
+@subsection Close a Named Semaphore
+@subsection Remove a Named Semaphore
+@subsection Lock a Semaphore
+@subsection Unlock a Semaphore
+@subsection Get the Value of a Semaphore
 @section Mutexes
-@subsubsection Mutex Initialization Attributes
-@subsubsection Initializing and Destroying a Mutex
-@subsubsection Locking and Unlocking a Mutex
+@subsection Mutex Initialization Attributes
+@subsection Initializing and Destroying a Mutex
+@subsection Locking and Unlocking a Mutex
 @section Condition Variables
-@subsubsection Condition Variable Initialization Attributes
-@subsubsection Initialization and Destroying Condition Variables
-@subsubsection Broadcasting and Signaling a Condition
-@subsubsection Waiting on a Condition
+@subsection Condition Variable Initialization Attributes
+@subsection Initialization and Destroying Condition Variables
+@subsection Broadcasting and Signaling a Condition
+@subsection Waiting on a Condition
 
Index: doc/posix1003.1/ch12.t
===================================================================
--- doc/posix1003.1/ch12.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch12.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -9,13 +9,13 @@
 @chapter Memory Management
 @section Memory Locking Functions
-@subsubsection Lock/Unlock the Address Space of a Process
-@subsubsection Lock/Unlock a Rand of Process Address Space
+@subsection Lock/Unlock the Address Space of a Process
+@subsection Lock/Unlock a Rand of Process Address Space
 @section Memory Mapping Functions
-@subsubsection Map Process Addresses to a Memory Object
-@subsubsection Unmap Previously Mapped Addresses
-@subsubsection Change Memory Protection
-@subsubsection Memory Object Synchronization
+@subsection Map Process Addresses to a Memory Object
+@subsection Unmap Previously Mapped Addresses
+@subsection Change Memory Protection
+@subsection Memory Object Synchronization
 @section Shared Memory Functions
-@subsubsection Open a Shared Memory Object
-@subsubsection Remove a Shared Memory Object
+@subsection Open a Shared Memory Object
+@subsection Remove a Shared Memory Object
 
Index: doc/posix1003.1/ch13.t
===================================================================
--- doc/posix1003.1/ch13.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch13.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -10,24 +10,24 @@
 @section Scheduling Parameters
 @section Scheduling Policies
-@subsubsection SCHED_FIFO
-@subsubsection SCHED_RR
-@subsubsection SCHED_OTHER
+@subsection SCHED_FIFO
+@subsection SCHED_RR
+@subsection SCHED_OTHER
 @section Process Scheduling Functions
-@subsubsection Set Scheduling Parameters
-@subsubsection Get Scheduling Parameters
-@subsubsection Set Scheduling Policy and Scheduling Parameters
-@subsubsection Get Scheduling Policy
-@subsubsection Yield Processor
-@subsubsection Get Scheduling Parameter Limits
+@subsection Set Scheduling Parameters
+@subsection Get Scheduling Parameters
+@subsection Set Scheduling Policy and Scheduling Parameters
+@subsection Get Scheduling Policy
+@subsection Yield Processor
+@subsection Get Scheduling Parameter Limits
 @section Thread Scheduling
-@subsubsection Thread Scheduling Attributes
-@subsubsection Scheduling Contention Scope
-@subsubsection Scheduling Allocation Domain
-@subsubsection Scheduling Documentation
+@subsection Thread Scheduling Attributes
+@subsection Scheduling Contention Scope
+@subsection Scheduling Allocation Domain
+@subsection Scheduling Documentation
 @section Thread Scheduling Functions
-@subsubsection Thread Creation Scheduling Attributes
-@subsubsection Dynamic Thread Scheduling Parameters Access
+@subsection Thread Creation Scheduling Attributes
+@subsection Dynamic Thread Scheduling Parameters Access
 @section Synchronization Scheduling
-@subsubsection Mutex Initialization Scheduling Attributes
-@subsubsection Change the Priority Ceiling of a Mutex
+@subsection Mutex Initialization Scheduling Attributes
+@subsection Change the Priority Ceiling of a Mutex
 
Index: doc/posix1003.1/ch14.t
===================================================================
--- doc/posix1003.1/ch14.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch14.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -9,13 +9,13 @@
 @chapter Clocks and Timers
 @section Data Definitions for Clocks and Timers
-@subsubsection Time Value Specification Structures
-@subsubsection Timer Event Notification Control Block
-@subsubsection Type Definitions
-@subsubsection Manifest Constants
+@subsection Time Value Specification Structures
+@subsection Timer Event Notification Control Block
+@subsection Type Definitions
+@subsection Manifest Constants
 @section Clock and Timer Functions
-@subsubsection Clocks
-@subsubsection Create a Per-Process Timer
-@subsubsection Delete a Per-Process Timer
-@subsubsection Per-Process Timers
-@subsubsection High Resolution Sleep
+@subsection Clocks
+@subsection Create a Per-Process Timer
+@subsection Delete a Per-Process Timer
+@subsection Per-Process Timers
+@subsection High Resolution Sleep
 
Index: doc/posix1003.1/ch15.t
===================================================================
--- doc/posix1003.1/ch15.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch15.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -9,13 +9,13 @@
 @chapter Message Passing
 @section Data Definitions for Message Queues
-@subsubsection Data Structures
+@subsection Data Structures
 @section Message Passing Functions
-@subsubsection Open a Message Queue
-@subsubsection Close a Message Queue
-@subsubsection Remove a Message Queue
-@subsubsection Send a Message to a Message Queue
-@subsubsection Receive a Message From a Message Queue
-@subsubsection Notify Process That a Message is Available on a Queue
-@subsubsection Set Message Queue Attributes
-@subsubsection Get Message Queue Attributes
+@subsection Open a Message Queue
+@subsection Close a Message Queue
+@subsection Remove a Message Queue
+@subsection Send a Message to a Message Queue
+@subsection Receive a Message From a Message Queue
+@subsection Notify Process That a Message is Available on a Queue
+@subsection Set Message Queue Attributes
+@subsection Get Message Queue Attributes
 
Index: doc/posix1003.1/ch16.t
===================================================================
--- doc/posix1003.1/ch16.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch16.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -10,11 +10,11 @@
 @section Threads
 @section Thread Functions
-@subsubsection Thread Creation Attributes
-@subsubsection Thread Creation
-@subsubsection Wait for Thread Termination
-@subsubsection Detaching a Thread
-@subsubsection Thread Termination
-@subsubsection Get Thread ID
-@subsubsection Compare Thread IDs
-@subsubsection Dynamic Package Initialization
+@subsection Thread Creation Attributes
+@subsection Thread Creation
+@subsection Wait for Thread Termination
+@subsection Detaching a Thread
+@subsection Thread Termination
+@subsection Get Thread ID
+@subsection Compare Thread IDs
+@subsection Dynamic Package Initialization
 
Index: doc/posix1003.1/ch17.t
===================================================================
--- doc/posix1003.1/ch17.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch17.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -9,6 +9,6 @@
 @chapter Thread-Specific Data
 @section Thread-Specific Data Functions
-@subsubsection Thread-Specific Data Key Creation
-@subsubsection Thread-Specific Data Management
-@subsubsection Thread-Specific Data Key Deletion
+@subsection Thread-Specific Data Key Creation
+@subsection Thread-Specific Data Management
+@subsection Thread-Specific Data Key Deletion
 
Index: doc/posix1003.1/ch18.t
===================================================================
--- doc/posix1003.1/ch18.t	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/ch18.t	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -10,16 +10,16 @@
 @section Thread Cancellation Overview
 @subsection Cancelability States
-@subsubsection Cancellation Points
-@subsubsection Thread Cancellation Cleanup Handlers
-@subsubsection Async-Cancel Safety
+@subsection Cancellation Points
+@subsection Thread Cancellation Cleanup Handlers
+@subsection Async-Cancel Safety
 @section Thread Cancellation Functions
-@subsubsection Canceling Execution of a Thread
-@subsubsection Setting Cancelability State
-@subsubsection Establishing Cancellation Handlers
+@subsection Canceling Execution of a Thread
+@subsection Setting Cancelability State
+@subsection Establishing Cancellation Handlers
 @section Language-Independent Cancellation Functionality
-@subsubsection Requesting Cancellation
-@subsubsection Associating Cleanup Code With Scopes
-@subsubsection Controlling Cancellation Within Scopes
-@subsubsection Defined Cancellation Sequence
-@subsubsection List of Cancellation Points
+@subsection Requesting Cancellation
+@subsection Associating Cleanup Code With Scopes
+@subsection Controlling Cancellation Within Scopes
+@subsection Defined Cancellation Sequence
+@subsection List of Cancellation Points
 
Index: doc/posix1003.1/posix1003_1.texi
===================================================================
--- doc/posix1003.1/posix1003_1.texi	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/posix1003_1.texi	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -17,5 +17,5 @@
 
 @c
-@c   Master file for the KA9Q TCP/IP Supplement
+@c   Master file for the POSIX 1003.1 Compliance Guide
 @c
 
@@ -26,5 +26,5 @@
 @format
 START-INFO-DIR-ENTRY
-* RTEMS KA9Q TCP/IP Supplement (posix1003_1):
+* RTEMS POSIX 1003.1 Compliance Guide (posix1003_1):
 END-INFO-DIR-ENTRY
 @end format
@@ -44,12 +44,12 @@
 @c  I don't really like having a short title page.  --joel
 @c
-@c @shorttitlepage RTEMS KA9Q TCP/IP Supplement
+@c @shorttitlepage RTEMS POSIX 1003.1 Compliance Guide
 
 @setchapternewpage odd
-@settitle RTEMS KA9Q TCP/IP Supplement
+@settitle RTEMS POSIX 1003.1 Compliance Guide
 @titlepage
 @finalout
 
-@title RTEMS KA9Q TCP/IP Supplement
+@title RTEMS POSIX 1003.1 Compliance Guide
 @subtitle Edition @value{edition}, for RTEMS @value{version}
 @sp 1
@@ -87,5 +87,5 @@
 @top posix1003_1
 
-This is the online version of the RTEMS KA9Q TCP/IP Supplement.
+This is the online version of the RTEMS POSIX 1003.1 Compliance Guide.
 
 @menu
@@ -132,5 +132,5 @@
 @c @printindex cp
 
-@c @contents
+@contents
 @bye
 
Index: doc/posix1003.1/preface.texi
===================================================================
--- doc/posix1003.1/preface.texi	(revision 2d19ed6c69296eeeb41796f2a8474c02234f4eb1)
+++ doc/posix1003.1/preface.texi	(revision 68feecfd86ac8c88b079fcdae42369a63c5e7a98)
@@ -7,4 +7,8 @@
 @c
 
+@ifinfo
+@node Preface, General, Top, Top
+@end ifinfo
+
 @unnumbered Preface
 